<?php declare(strict_types=1);

namespace Plugin\jtl_trustami_produkt_siegel;
use JTL\Plugin\PluginInterface;

/**
 * Class Bootstrap
 * @package Plugin\jtl_trustami_produkt_siegel
 */
class Helper
{   
    /**
     * TestHelper constructor.
     * @param PluginInterface   $extension
     * @param DbInterface       $db
     * @param JTLCacheInterface $cache
     */
    public function __construct(PluginInterface $extension)
    {
        $this->extension = $extension;
    }

    public function assignScriptParam($filteredItem) {
        $strParam = NULL;
        if (isset($filteredItem->kVaterArtikel) && $filteredItem->kVaterArtikel != $filteredItem->kArtikel) {
            $filteredItem->fuelleArtikel($filteredItem->kVaterArtikel, $filteredItem->getDetailOptions());
        }

        if ($filteredItem->holeBewertung()->Bewertungen->oBewertungGesamt->nAnzahl > 0) {
            $strParam = ' data-ort="'.$filteredItem->holeBewertung()->Bewertungen->oBewertungGesamt->nAnzahl.'" data-ors="'.$filteredItem->holeBewertung()->Bewertungen->oBewertungGesamt->fDurchschnitt.'"';
        }
        return $strParam;
    }

    public function getGtinFromArtikel($filteredItem) {
        $gtinsStr = array();    
        $tmpGtins = $filteredItem->FunktionsAttribute;
        if (array_key_exists('gtin', $tmpGtins)) {
            $gtinsStr[] = preg_split("(\n|\s)",trim($tmpGtins["gtin"]));
        }

        if (isset($filteredItem->cBarcode) && !empty($filteredItem->cBarcode)){
            $gtinsStr[] = $filteredItem->cBarcode;
        }
        if (!empty($gtinsStr))
            $gtinsStr = join(' ,', $gtinsStr);

        return $gtinsStr;
    }

    public function buildApiPostObjects($filteredItems, $calcRevs) {
        $gtinItems = array();
        foreach ($filteredItems as $filteredItem) {
            $data = ["gtin" => $this->getGtinFromArtikel($filteredItem), "key" => $filteredItem->cArtNr];            
            if (isset($data["gtin"])) {
                if (isset($filteredItem->kVaterArtikel) && $filteredItem->kVaterArtikel != $filteredItem->kArtikel) {
                    $filteredItem->fuelleArtikel($filteredItem->kVaterArtikel, $filteredItem->getDetailOptions());
                }
                if ($calcRevs != "0" && $filteredItem->holeBewertung()->Bewertungen->oBewertungGesamt->nAnzahl > 0) {
                    $data["ort"] = $filteredItem->holeBewertung()->Bewertungen->oBewertungGesamt->nAnzahl;
                    $data['ors'] = $filteredItem->holeBewertung()->Bewertungen->oBewertungGesamt->fDurchschnitt;
                }
            }
            array_push($gtinItems, $data);
        }
        return $gtinItems;
    }
}