<?php

namespace Plugin\jtl_trustami_produkt_siegel;

class TrustamiProductApi
{
    private $apiKey;
    private $curl;
    private $getFields;
    private $postFields;
    private $sendingFile;

    public function __construct($apiKey)
    {
        $this->curl = curl_init();
        $this->apiKey = $apiKey;
        $this->postFields = array();
        $this->getFields = array();
        $this->sendingFile = FALSE;

        curl_setopt($this->curl,CURLOPT_HEADER, 0);
        curl_setopt($this->curl,CURLOPT_FRESH_CONNECT, 1);
        curl_setopt($this->curl,CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($this->curl,CURLOPT_FORBID_REUSE, 1);
        curl_setopt($this->curl,CURLOPT_TIMEOUT, 4);

        curl_setopt($this->curl,CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
        curl_setopt($this->curl,CURLOPT_USERPWD, $this->apiKey);
    }

    public function __get($property) {
        if (property_exists($this, $property)) {
            return $this->$property;
        }
    }

    public function __set($property, $value) {
        if (property_exists($this, $property)) {
            $this->$property = $value;
        }

        return $this;
    }

    public function setOption($name, $value)
    {
        curl_setopt($this->curl, $name, $value);
        return $this;
    }

    public function postMultipleProducts($postArgs){
        $url = "https://api.trustami.com/products/multiple/";
        curl_setopt($this->curl, CURLOPT_POST, 1);
        curl_setopt($this->curl, CURLOPT_URL, $url);
        curl_setopt($this->curl, CURLOPT_POSTFIELDS, http_build_query($postArgs));
        $returnData = curl_exec($this->curl);
        $errno = curl_errno($this->curl);
        $error = curl_error($this->curl);
        if($errno)
        {
            curl_close ($this->curl);
            trigger_error($error);
        }
        curl_close ($this->curl);
        return $returnData;
    }

    public function getCurlVersion(){
        return curl_version();
    }
}